#!/bin/sh

. /etc/PG.conf

CLOUD_CONF=${PGETC}/cloud.conf
	
[ -e ${CLOUD_CONF} ] && . ${CLOUD_CONF}

getblackip()
{
	cdir=`pwd`

	# Download
	err=`fetch 'http://www.panabit.com/newblackip.txt'`
	if [ -f ${cdir}/newblackip.txt ]; then
		# ʹһIPΪIP
		tbname="IP"

		# Ƿ
		err=`floweye table list | grep ${tbname}`
		if [ "${err}" = "" ]; then
			err=`floweye table add name=$tbname`
			tbid=`floweye table list | grep ${tbname} | cut -d' ' -f1`
			clear=0
		else
			clear=1
			tbid=`echo ${err} | cut -d' ' -f1`
		fi
	
		err=`floweye table loadfile tid=${tbid} file=${cdir}/newblackip.txt clear=${clear}`
	
		# Ƿв
		defgrp=`floweye policy getdefgrp | cut -d' ' -f1`
	
		# Ƿвڵ
		active_polid=0
		result=`floweye policy listtime | grep active`
		while read id active disabled month startday endday starthour startmin startsec endhour endmin endsec polid polname ipmin ipmax theothers
		do
			[ "${polid}" != "" ] && active_polid=${polid}
		done << EOF
			${result}
EOF
	
		if [ "${defgrp}" != "0" ]; then
			# Ƿ
			err=`floweye policy getgrp group=${defgrp} | cut -d' ' -f13`
			if [ "${err}" = "${tbname}" ]; then
				echo "ok"
				return
			fi 
			err=`floweye policy addrule group=${defgrp} id=2 bridge=any dir=both app=any inip=any outip=${tbid} action=deny iprate=0 next=0 tos=0 pri=0 natip=0 hasms=0 qqcnt=0 vlan=0 desc=`
			if [ "$?" != "0" ]; then
				echo ${err}
				return
			fi 
			echo "ok"
			return
		fi
	
		if [ "${active_polid}" != "0" ]; then
			# Ƿ
			err=`floweye policy getgrp group=${active_polid} | cut -d' ' -f13`
			if [ "${err}" = "${tbname}" ]; then
				echo "ok"
				return
			fi

			err=`floweye policy addrule group=${active_polid} id=2 bridge=any dir=both app=any inip=any outip=${tbid} action=deny iprate=0 next=0 tos=0 pri=0 natip=0 hasms=0 qqcnt=0 vlan=0 desc=`
			if [ "$?" != "0" ]; then
				echo ${err}
				return
			fi
			return
		fi
	
		polname="ƽ̨ϲ"
		# ûвδбȵĲ飬򴴽
		err=`floweye policy addgrp ${polname}`
		polid=`floweye policy listgrp | grep ${polname} | cut -d' ' -f1`
		# 
		err=`floweye policy addrule group=${polid} id=2 bridge=any dir=both app=any inip=any outip=${tbid} action=deny iprate=0 next=0 tos=0 pri=0 natip=0 hasms=0 qqcnt=0 vlan=0 desc=`
		#豸ΪĬϵ
		err=`floweye policy setdefgrp ${polname}`
	fi
}

[ "${MT_BLACKIP}" = "1" ] && getblackip

while true
do
	hour=`date +%H`
	min=`date +%M`

	if [ "${MT_BLACKIP}" = "1" -a "${hour}" = "08" -a "${min}" = "00" ]; then
		getblackip
	fi

	sleep 60
done
